import { diff } from 'deep-diff';

function dataHandler(val, oldVal) {
  if (!oldVal) {
    this.renderChart(this.chartData, this.options);
  } else {
    var updates = val && oldVal ? diff(oldVal.datasets, val.datasets) : undefined;
    console.log(updates);
    console.log({
      val: val,
      oldVal: oldVal
    });

    if (updates && updates.length > 0) {
      console.log(updates);

      if (this.$data._chart) {
        console.log('updating...');

        this.$data._chart.update();
      }
    }
  }
}

export var reactiveData = {
  data: function data() {
    return {
      chartData: null
    };
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export var reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export default {
  reactiveData: reactiveData,
  reactiveProp: reactiveProp
};