import { diff } from 'deep-diff'

function dataHandler (val, oldVal) {
  if (!oldVal) {
    this.renderChart(this.chartData, this.options)
  } else {
    let updates = val && oldVal ? diff(oldVal.datasets, val.datasets) : undefined
    console.log(updates)
    console.log({ val, oldVal })
    if (updates && updates.length > 0) {
      console.log(updates)
      if (this.$data._chart) {
        console.log('updating...')
        this.$data._chart.update()
      }
    }
  }
}

export const reactiveData = {
  data () {
    return {
      chartData: null
    }
  },

  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export const reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export default {
  reactiveData,
  reactiveProp
}
